#region Copyright Syncfusion Inc. 2001 - 2019
// Copyright Syncfusion Inc. 2001 - 2019. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Reflection;
using Syncfusion.PivotAnalysis.Base;
using Syncfusion.Windows.Forms;

namespace CustomizationDemo
{
    public partial class Form1 : MetroForm
    {
        #region Private Members

        private bool isExpanded = true;

        bool needToRefresh = false;

        #endregion

        #region Constructor

        public Form1()
        {
            InitializeComponent();
            InitializeGrid();
            this.pivotGridControl1.PivotEngine.PivotSchemaChanged += PivotEngine_PivotSchemaChanged;
            this.Load += Form1_Load;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            PivotItem item = new PivotItem
            {
                FieldMappingName = "Country",
                FieldCaption = "Country_1",
                FieldHeader = "Country_1",
                TotalHeader = "Total"
            };

            System.Reflection.FieldInfo field = this.pivotGridControl1.TableControl.GetType().GetField("completeTablelist", BindingFlags.Public | BindingFlags.NonPublic | BindingFlags.Instance | BindingFlags.Static);
            List<System.Collections.Generic.KeyValuePair<string, PivotItem>> tableList = field.GetValue(this.pivotGridControl1.TableControl) as List<KeyValuePair<string, PivotItem>>;
            if (tableList.Any(x => x.Key == "Country"))
            {
                int index = tableList.FindIndex(j => j.Key == "Country");
                KeyValuePair<string, PivotItem> newValue = new KeyValuePair<string, PivotItem>("Country_1", item);
                tableList[index] = newValue;
            }

            System.Reflection.FieldInfo field1 = this.pivotGridControl1.TableControl.GetType().GetField("propertyDescTableList", BindingFlags.Public | BindingFlags.NonPublic | BindingFlags.Instance | BindingFlags.Static);
            Dictionary<string, PivotItem> tableList1 = field1.GetValue(this.pivotGridControl1.TableControl) as Dictionary<string, PivotItem>;
            if (tableList1.Any(x => x.Key == "Country"))
            {
                int index = tableList1.ToList().FindIndex(j => j.Key == "Country");
                tableList1.Remove("Country");
                tableList1.Add("Country_1", item);
            }
            this.pivotGridControl1.ShowPivotTableFieldList = false;
            this.pivotGridControl1.ShowPivotTableFieldList = true;
        }

        private void PivotEngine_PivotSchemaChanged(object sender, PivotSchemaChangedArgs e)
        {
            System.Reflection.FieldInfo field2 = this.pivotGridControl1.GetType().GetField("FilterItems", BindingFlags.Public | BindingFlags.NonPublic | BindingFlags.Instance | BindingFlags.Static);
            ObservableCollection<FilterItemsCollection> values = field2.GetValue(this.pivotGridControl1) as ObservableCollection<FilterItemsCollection>;
            foreach (FilterItemsCollection value in values)
            {
                if (value.FieldCaption == "Country")
                {
                    value.FieldCaption = "Country_1";
                    needToRefresh = true;
                }
            }

            if (needToRefresh)
            {
                this.pivotGridControl1.ShowPivotTableFieldList = false;
                this.pivotGridControl1.ShowPivotTableFieldList = true;
                needToRefresh = false;
            }
        }

        #endregion

        #region Grid Setting

        private void InitializeGrid()
        {
            pivotGridControl1.GridVisualStyles = GridVisualStyles.Metro;
            pivotGridControl1.ItemSource = ProductSalesData.GetSalesData();
            
            //used to add PivotRows.
            //pivotGridControl1.PivotRows.Add(new PivotItem { FieldMappingName = "Product", FieldCaption = "Product_1", TotalHeader = "Total" });
            //pivotGridControl1.PivotRows.Add(new PivotItem { FieldMappingName = "Product", FieldCaption = "Product_2", TotalHeader = "Total" });
            //pivotGridControl1.PivotRows.Add(new PivotItem { FieldMappingName = "Date", TotalHeader = "Total" });

            //used to add PivotColumns.
            //pivotGridControl1.PivotColumns.Add(new PivotItem { FieldMappingName = "Country", TotalHeader = "Total" });
            //pivotGridControl1.PivotColumns.Add(new PivotItem { FieldMappingName = "State", TotalHeader = "Total" });

            pivotGridControl1.PivotCalculations.Add(new PivotComputationInfo { FieldName = "Quantity", Format = "#,##0" });

            //shows the pivot table field list.
            pivotGridControl1.ShowPivotTableFieldList = true;

            pivotGridControl1.ShowGroupBar = true;
            pivotGridControl1.TableControl.FreezeHeaders = true;
        }

        #endregion

    }
}